import { PluginDevMode, PluginClient, PluginOptions } from './client';
import { ModuleProfile } from '../types';
import { ApiMap } from './api';
/**
 * Check if the sender has the right origin
 * @param origin The origin of the incoming message
 * @param devMode Devmode options
 */
export declare function checkOrigin(origin: string, devMode?: PluginDevMode): boolean;
/**
 * Start listening on the IDE though PostMessage
 * @param store A store to put the messages into
 */
export declare function connectIframe(client: PluginClient): void;
/**
 * Create a plugin client that listen on PostMessage
 */
export declare function createIframeClient<T extends ModuleProfile>(options?: Partial<PluginOptions<T>>): ApiMap<T> & PluginClient;
