import { ViewPlugin, ViewProfile } from './view';
interface IframeProfile extends ViewProfile {
    url: string;
}
export declare class IframePlugin extends ViewPlugin {
    profile: IframeProfile;
    private readonly listener;
    private id;
    private iframe;
    private origin;
    private source;
    private pendingRequest;
    constructor(profile: IframeProfile);
    deactivate(): void;
    /** Call a method from this plugin */
    protected callPluginMethod(key: string, payload: any[]): Promise<{}>;
    /** Get message from the iframe */
    private getMessage;
    /**
     * Post a message to the iframe of this plugin
     * @param message The message to post
     */
    private postMessage;
    /**
     * Create and return the iframe
     */
    render(): HTMLIFrameElement;
}
export {};
