import { Plugin, Profile } from './abstract';
import { Api } from 'src/types';
export declare type LibraryApi<T extends Api, P extends Profile> = {
    [method in P['methods'][number]]: T['methods'][method];
} & {
    events: {
        on: (name: string, cb: (...args: any[]) => void) => void;
        emit: (name: string, ...args: any[]) => void;
    };
};
export interface LibraryProfile {
    events?: string[];
    notifications?: {
        [name: string]: string[];
    };
}
export declare class LibraryPlugin<T extends Api, P extends (Profile & LibraryProfile)> extends Plugin {
    private library;
    profile: P;
    constructor(library: LibraryApi<T, P>, profile: P);
    activate(): void;
    /** Call a method from this plugin */
    protected callPluginMethod(key: string, payload: any[]): any;
}
