export declare class BaseStore<S extends {}> {
    private initialState;
    protected state: S;
    constructor(initialState: S);
    /**
     * Update one field of the state
     * @param state The part of the state updated
     */
    update(state: Partial<S>): any;
    update<R>(callback: (store: S) => Partial<S>): any;
    /** Get the state or a part of it */
    get(): S;
    get<K extends keyof S>(key: K): S[K];
    get<R>(query: (store: S) => R): R;
    /** Reset the state its initial value */
    resetState(): void;
}
